Index: XIOS/branchs/xios-1.0/src/interface/c_attr/icfile_attr.cpp
===================================================================
--- XIOS/branchs/xios-1.0/src/interface/c_attr/icfile_attr.cpp	(revision 693)
+++ XIOS/branchs/xios-1.0/src/interface/c_attr/icfile_attr.cpp	(revision 703)
@@ -333,4 +333,32 @@
   
   
+  void cxios_set_file_time_counter(file_Ptr file_hdl, const char * time_counter, int time_counter_size)
+  {
+    std::string time_counter_str;
+    if(!cstr2string(time_counter, time_counter_size, time_counter_str)) return;
+     CTimer::get("XIOS").resume();
+    file_hdl->time_counter.fromString(time_counter_str);
+    file_hdl->sendAttributToServer(file_hdl->time_counter);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_file_time_counter(file_Ptr file_hdl, char * time_counter, int time_counter_size)
+  {
+     CTimer::get("XIOS").resume();
+    if(!string_copy(file_hdl->time_counter.getInheritedStringValue(),time_counter , time_counter_size))
+      ERROR("void cxios_get_file_time_counter(file_Ptr file_hdl, char * time_counter, int time_counter_size)", <<"Input string is to short");
+     CTimer::get("XIOS").suspend();
+  }
+  
+  bool cxios_is_defined_file_time_counter(file_Ptr file_hdl )
+  {
+    CTimer::get("XIOS").resume();
+    bool isDefined = file_hdl->time_counter.hasInheritedValue();
+    CTimer::get("XIOS").suspend();
+    return isDefined;
+  }
+  
+  
+  
   void cxios_set_file_type(file_Ptr file_hdl, const char * type, int type_size)
   {
Index: XIOS/branchs/xios-1.0/src/interface/c_attr/icfilegroup_attr.cpp
===================================================================
--- XIOS/branchs/xios-1.0/src/interface/c_attr/icfilegroup_attr.cpp	(revision 693)
+++ XIOS/branchs/xios-1.0/src/interface/c_attr/icfilegroup_attr.cpp	(revision 703)
@@ -361,4 +361,32 @@
   
   
+  void cxios_set_filegroup_time_counter(filegroup_Ptr filegroup_hdl, const char * time_counter, int time_counter_size)
+  {
+    std::string time_counter_str;
+    if(!cstr2string(time_counter, time_counter_size, time_counter_str)) return;
+     CTimer::get("XIOS").resume();
+    filegroup_hdl->time_counter.fromString(time_counter_str);
+    filegroup_hdl->sendAttributToServer(filegroup_hdl->time_counter);
+     CTimer::get("XIOS").suspend();
+  }
+  
+  void cxios_get_filegroup_time_counter(filegroup_Ptr filegroup_hdl, char * time_counter, int time_counter_size)
+  {
+     CTimer::get("XIOS").resume();
+    if(!string_copy(filegroup_hdl->time_counter.getInheritedStringValue(),time_counter , time_counter_size))
+      ERROR("void cxios_get_filegroup_time_counter(filegroup_Ptr filegroup_hdl, char * time_counter, int time_counter_size)", <<"Input string is to short");
+     CTimer::get("XIOS").suspend();
+  }
+  
+  bool cxios_is_defined_filegroup_time_counter(filegroup_Ptr filegroup_hdl )
+  {
+    CTimer::get("XIOS").resume();
+    bool isDefined = filegroup_hdl->time_counter.hasInheritedValue();
+    CTimer::get("XIOS").suspend();
+    return isDefined;
+  }
+  
+  
+  
   void cxios_set_filegroup_type(filegroup_Ptr filegroup_hdl, const char * type, int type_size)
   {
Index: XIOS/branchs/xios-1.0/src/interface/fortran_attr/file_interface_attr.f90
===================================================================
--- XIOS/branchs/xios-1.0/src/interface/fortran_attr/file_interface_attr.f90	(revision 693)
+++ XIOS/branchs/xios-1.0/src/interface/fortran_attr/file_interface_attr.f90	(revision 703)
@@ -253,4 +253,25 @@
     
     
+    SUBROUTINE cxios_set_file_time_counter(file_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_set_file_time_counter
+    
+    SUBROUTINE cxios_get_file_time_counter(file_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_get_file_time_counter
+    
+    FUNCTION cxios_is_defined_file_time_counter(file_hdl ) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_file_time_counter
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+    END FUNCTION cxios_is_defined_file_time_counter
+    
+    
     SUBROUTINE cxios_set_file_type(file_hdl, type, type_size) BIND(C)
       USE ISO_C_BINDING
Index: XIOS/branchs/xios-1.0/src/interface/fortran_attr/filegroup_interface_attr.f90
===================================================================
--- XIOS/branchs/xios-1.0/src/interface/fortran_attr/filegroup_interface_attr.f90	(revision 693)
+++ XIOS/branchs/xios-1.0/src/interface/fortran_attr/filegroup_interface_attr.f90	(revision 703)
@@ -274,4 +274,25 @@
     
     
+    SUBROUTINE cxios_set_filegroup_time_counter(filegroup_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_set_filegroup_time_counter
+    
+    SUBROUTINE cxios_get_filegroup_time_counter(filegroup_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_get_filegroup_time_counter
+    
+    FUNCTION cxios_is_defined_filegroup_time_counter(filegroup_hdl ) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_filegroup_time_counter
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+    END FUNCTION cxios_is_defined_filegroup_time_counter
+    
+    
     SUBROUTINE cxios_set_filegroup_type(filegroup_hdl, type, type_size) BIND(C)
       USE ISO_C_BINDING
Index: XIOS/branchs/xios-1.0/src/interface/fortran_attr/ifile_attr.F90
===================================================================
--- XIOS/branchs/xios-1.0/src/interface/fortran_attr/ifile_attr.F90	(revision 693)
+++ XIOS/branchs/xios-1.0/src/interface/fortran_attr/ifile_attr.F90	(revision 703)
@@ -13,5 +13,5 @@
   SUBROUTINE xios(set_file_attr)  &
     ( file_id, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-    , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
     IMPLICIT NONE
@@ -31,4 +31,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
       
@@ -36,5 +37,5 @@
       CALL xios(set_file_attr_hdl_)   &
       ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-      , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
   END SUBROUTINE xios(set_file_attr)
@@ -42,5 +43,5 @@
   SUBROUTINE xios(set_file_attr_hdl)  &
     ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-    , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
     IMPLICIT NONE
@@ -59,9 +60,10 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
       
       CALL xios(set_file_attr_hdl_)  &
       ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-      , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
   END SUBROUTINE xios(set_file_attr_hdl)
@@ -69,5 +71,6 @@
   SUBROUTINE xios(set_file_attr_hdl_)   &
     ( file_hdl, compression_level_, description_, enabled_, min_digits_, name_, name_suffix_, output_freq_  &
-    , output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_, type_ )
+    , output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_, time_counter_, type_  &
+     )
     
     IMPLICIT NONE
@@ -86,4 +89,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
       
@@ -137,4 +141,8 @@
       ENDIF
       
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_set_file_time_counter(file_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+      
       IF (PRESENT(type_)) THEN
         CALL cxios_set_file_type(file_hdl%daddr, type_, len(type_))
@@ -147,5 +155,5 @@
   SUBROUTINE xios(get_file_attr)  &
     ( file_id, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-    , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
     IMPLICIT NONE
@@ -165,4 +173,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
       
@@ -170,5 +179,5 @@
       CALL xios(get_file_attr_hdl_)   &
       ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-      , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
   END SUBROUTINE xios(get_file_attr)
@@ -176,5 +185,5 @@
   SUBROUTINE xios(get_file_attr_hdl)  &
     ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-    , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
     IMPLICIT NONE
@@ -193,9 +202,10 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
       
       CALL xios(get_file_attr_hdl_)  &
       ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-      , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
   END SUBROUTINE xios(get_file_attr_hdl)
@@ -203,5 +213,6 @@
   SUBROUTINE xios(get_file_attr_hdl_)   &
     ( file_hdl, compression_level_, description_, enabled_, min_digits_, name_, name_suffix_, output_freq_  &
-    , output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_, type_ )
+    , output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_, time_counter_, type_  &
+     )
     
     IMPLICIT NONE
@@ -220,4 +231,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
       
@@ -271,4 +283,8 @@
       ENDIF
       
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_get_file_time_counter(file_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+      
       IF (PRESENT(type_)) THEN
         CALL cxios_get_file_type(file_hdl%daddr, type_, len(type_))
@@ -281,5 +297,5 @@
   SUBROUTINE xios(is_defined_file_attr)  &
     ( file_id, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-    , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
     IMPLICIT NONE
@@ -310,4 +326,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -316,5 +334,5 @@
       CALL xios(is_defined_file_attr_hdl_)   &
       ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-      , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
   END SUBROUTINE xios(is_defined_file_attr)
@@ -322,5 +340,5 @@
   SUBROUTINE xios(is_defined_file_attr_hdl)  &
     ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-    , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
     IMPLICIT NONE
@@ -350,4 +368,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -355,5 +375,5 @@
       CALL xios(is_defined_file_attr_hdl_)  &
       ( file_hdl, compression_level, description, enabled, min_digits, name, name_suffix, output_freq  &
-      , output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter, type )
     
   END SUBROUTINE xios(is_defined_file_attr_hdl)
@@ -361,5 +381,6 @@
   SUBROUTINE xios(is_defined_file_attr_hdl_)   &
     ( file_hdl, compression_level_, description_, enabled_, min_digits_, name_, name_suffix_, output_freq_  &
-    , output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_, type_ )
+    , output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_, time_counter_, type_  &
+     )
     
     IMPLICIT NONE
@@ -389,4 +410,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq_
       LOGICAL(KIND=C_BOOL) :: sync_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_
+      LOGICAL(KIND=C_BOOL) :: time_counter__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
@@ -452,4 +475,9 @@
       ENDIF
       
+      IF (PRESENT(time_counter_)) THEN
+        time_counter__tmp=cxios_is_defined_file_time_counter(file_hdl%daddr)
+        time_counter_=time_counter__tmp
+      ENDIF
+      
       IF (PRESENT(type_)) THEN
         type__tmp=cxios_is_defined_file_type(file_hdl%daddr)
Index: XIOS/branchs/xios-1.0/src/interface/fortran_attr/ifilegroup_attr.F90
===================================================================
--- XIOS/branchs/xios-1.0/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 693)
+++ XIOS/branchs/xios-1.0/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 703)
@@ -13,5 +13,6 @@
   SUBROUTINE xios(set_filegroup_attr)  &
     ( filegroup_id, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
     
     IMPLICIT NONE
@@ -32,4 +33,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
       
@@ -37,5 +39,6 @@
       CALL xios(set_filegroup_attr_hdl_)   &
       ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+      , type )
     
   END SUBROUTINE xios(set_filegroup_attr)
@@ -43,5 +46,6 @@
   SUBROUTINE xios(set_filegroup_attr_hdl)  &
     ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
     
     IMPLICIT NONE
@@ -61,9 +65,11 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
       
       CALL xios(set_filegroup_attr_hdl_)  &
       ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+      , type )
     
   END SUBROUTINE xios(set_filegroup_attr_hdl)
@@ -72,5 +78,5 @@
     ( filegroup_hdl, compression_level_, description_, enabled_, group_ref_, min_digits_, name_  &
     , name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_  &
-    , type_ )
+    , time_counter_, type_ )
     
     IMPLICIT NONE
@@ -90,4 +96,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
       
@@ -145,4 +152,8 @@
       ENDIF
       
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_set_filegroup_time_counter(filegroup_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+      
       IF (PRESENT(type_)) THEN
         CALL cxios_set_filegroup_type(filegroup_hdl%daddr, type_, len(type_))
@@ -155,5 +166,6 @@
   SUBROUTINE xios(get_filegroup_attr)  &
     ( filegroup_id, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
     
     IMPLICIT NONE
@@ -174,4 +186,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
       
@@ -179,5 +192,6 @@
       CALL xios(get_filegroup_attr_hdl_)   &
       ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+      , type )
     
   END SUBROUTINE xios(get_filegroup_attr)
@@ -185,5 +199,6 @@
   SUBROUTINE xios(get_filegroup_attr_hdl)  &
     ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
     
     IMPLICIT NONE
@@ -203,9 +218,11 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
       
       CALL xios(get_filegroup_attr_hdl_)  &
       ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+      , type )
     
   END SUBROUTINE xios(get_filegroup_attr_hdl)
@@ -214,5 +231,5 @@
     ( filegroup_hdl, compression_level_, description_, enabled_, group_ref_, min_digits_, name_  &
     , name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_  &
-    , type_ )
+    , time_counter_, type_ )
     
     IMPLICIT NONE
@@ -232,4 +249,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
       
@@ -287,4 +305,8 @@
       ENDIF
       
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_get_filegroup_time_counter(filegroup_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+      
       IF (PRESENT(type_)) THEN
         CALL cxios_get_filegroup_type(filegroup_hdl%daddr, type_, len(type_))
@@ -297,5 +319,6 @@
   SUBROUTINE xios(is_defined_filegroup_attr)  &
     ( filegroup_id, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
     
     IMPLICIT NONE
@@ -328,4 +351,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -334,5 +359,6 @@
       CALL xios(is_defined_filegroup_attr_hdl_)   &
       ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+      , type )
     
   END SUBROUTINE xios(is_defined_filegroup_attr)
@@ -340,5 +366,6 @@
   SUBROUTINE xios(is_defined_filegroup_attr_hdl)  &
     ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
     
     IMPLICIT NONE
@@ -370,4 +397,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -375,5 +404,6 @@
       CALL xios(is_defined_filegroup_attr_hdl_)  &
       ( filegroup_hdl, compression_level, description, enabled, group_ref, min_digits, name, name_suffix  &
-      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+      , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+      , type )
     
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl)
@@ -382,5 +412,5 @@
     ( filegroup_hdl, compression_level_, description_, enabled_, group_ref_, min_digits_, name_  &
     , name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_, sync_freq_  &
-    , type_ )
+    , time_counter_, type_ )
     
     IMPLICIT NONE
@@ -412,4 +442,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq_
       LOGICAL(KIND=C_BOOL) :: sync_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_
+      LOGICAL(KIND=C_BOOL) :: time_counter__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
@@ -480,4 +512,9 @@
       ENDIF
       
+      IF (PRESENT(time_counter_)) THEN
+        time_counter__tmp=cxios_is_defined_filegroup_time_counter(filegroup_hdl%daddr)
+        time_counter_=time_counter__tmp
+      ENDIF
+      
       IF (PRESENT(type_)) THEN
         type__tmp=cxios_is_defined_filegroup_type(filegroup_hdl%daddr)