Index: XIOS/trunk/src/attribute_map.cpp
===================================================================
--- XIOS/trunk/src/attribute_map.cpp	(revision 649)
+++ XIOS/trunk/src/attribute_map.cpp	(revision 778)
@@ -226,8 +226,11 @@
          for (; it != end; it++)
          {
-           oss << std::endl << iendl;
-           it->second->generateCInterface(oss, className);
-           oss << iendl;
-           it->second->generateCInterfaceIsDefined(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << std::endl << iendl;
+             it->second->generateCInterface(oss, className);
+             oss << iendl;
+             it->second->generateCInterfaceIsDefined(oss, className);
+           }
          }
       }
@@ -238,8 +241,11 @@
          for (; it != end; it++)
          {
-           oss << std::endl << iendl;
-           it->second->generateFortran2003Interface(oss, className);
-           oss << iendl;
-           it->second->generateFortran2003InterfaceIsDefined(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << std::endl << iendl;
+             it->second->generateFortran2003Interface(oss, className);
+             oss << iendl;
+             it->second->generateFortran2003InterfaceIsDefined(oss, className);
+           }
          }
       }
@@ -258,9 +264,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName() << "_";
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName() << "_";
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -274,12 +283,18 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceDeclaration_(oss, className);
-         }
-
-         for (it = begin; it != end; it++)
-         {
-           oss << std::endl << iendl;
-           it->second->generateFortranInterfaceBody_(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceDeclaration_(oss, className);
+           }
+         }
+
+         for (it = begin; it != end; it++)
+         {
+           if (it->second->isPublic())
+           {
+             oss << std::endl << iendl;
+             it->second->generateFortranInterfaceBody_(oss, className);
+           }
          }
 
@@ -299,9 +314,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName() << "_";
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName() << "_";
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -315,12 +333,18 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceGetDeclaration_(oss, className);
-         }
-
-         for (it = begin; it != end; it++)
-         {
-           oss << std::endl << iendl;
-           it->second->generateFortranInterfaceGetBody_(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceGetDeclaration_(oss, className);
+           }
+         }
+
+         for (it = begin; it != end; it++)
+         {
+           if (it->second->isPublic())
+           {
+             oss << std::endl << iendl;
+             it->second->generateFortranInterfaceGetBody_(oss, className);
+           }
          }
 
@@ -340,9 +364,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName() << "_";
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName() << "_";
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -356,12 +383,18 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceIsDefinedDeclaration_(oss, className);
-         }
-
-         for (it = begin; it != end; it++)
-         {
-           oss << std::endl << iendl;
-           it->second->generateFortranInterfaceIsDefinedBody_(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceIsDefinedDeclaration_(oss, className);
+           }
+         }
+
+         for (it = begin; it != end; it++)
+         {
+           if (it->second->isPublic())
+           {
+             oss << std::endl << iendl;
+             it->second->generateFortranInterfaceIsDefinedBody_(oss, className);
+           }
          }
 
@@ -381,9 +414,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -397,6 +433,9 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceDeclaration(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceDeclaration(oss, className);
+           }
          }
 
@@ -410,9 +449,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -434,9 +476,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -450,6 +495,9 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceGetDeclaration(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceGetDeclaration(oss, className);
+           }
          }
 
@@ -463,9 +511,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -487,9 +538,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -503,6 +557,9 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceIsDefinedDeclaration(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceIsDefinedDeclaration(oss, className);
+           }
          }
 
@@ -516,9 +573,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -540,9 +600,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -558,6 +621,9 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceDeclaration(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceDeclaration(oss, className);
+           }
          }
 
@@ -571,9 +637,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -595,9 +664,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -613,6 +685,9 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceGetDeclaration(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceGetDeclaration(oss, className);
+           }
          }
 
@@ -626,9 +701,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -650,9 +728,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }
@@ -668,6 +749,9 @@
          for (it = begin; it != end; it++)
          {
-           oss << iendl;
-           it->second->generateFortranInterfaceIsDefinedDeclaration(oss, className);
+           if (it->second->isPublic())
+           {
+             oss << iendl;
+             it->second->generateFortranInterfaceIsDefinedDeclaration(oss, className);
+           }
          }
 
@@ -681,9 +765,12 @@
          for (it = begin; it != end; it++)
          {
-           oss << ", " << it->second->getName();
-           if (oss.tellp() - startPos > 90)
-           {
-             oss << "  &" << iendl;
-             startPos = oss.tellp();
+           if (it->second->isPublic())
+           {
+             oss << ", " << it->second->getName();
+             if (oss.tellp() - startPos > 90)
+             {
+               oss << "  &" << iendl;
+               startPos = oss.tellp();
+             }
            }
          }